function obj = algoobj_cfs1()

%% Doublets SPC controller algorithm
obj = SCDclass_algo('algo_cfs1');

%% Timing of the algorithm
obj=obj.settiming(-1,1e-3,1.0);

%% Fixed parameters init functions 
obj=obj.addfpinitfcn('algo_cfs1_loadfp','algo_cfs1_fp');

%% Tunable parameters structure name
obj=obj.addtunparamstruct('algo_cfs1_tp', @()algo_cfs1_loadtp(), false);

%% Tunable parameters
parshot=2;
mdsserver='scd.epfl.ch';
mdstree  ='scdds';
obj=obj.addparameter(SCDclass_mdsparnumeric('cfs1.params.enable'        ,'enable'          ,'mdshelp','a bool param',...
    'mdsvalid','1','srcsrv',mdsserver,'srctree',mdstree)); 
obj=obj.addparameter(SCDclass_mdsparnumeric('cfs1.params.gain'          ,'gain'            ,'mdshelp','a tunable gain',...
    'mdsvalid','1','srcsrv',mdsserver,'srctree',mdstree));
obj=obj.addparameter(SCDclass_mdsparnumeric('cfs1.params.refmodel.gain' ,'refmodel.gain'   ,'mdshelp','a tunable gain',...
    'mdsvalid','1','srcsrv',mdsserver,'srctree',mdstree));
obj=obj.addparameter(SCDclass_mdsparnumeric('cfs1.params.rowvect'       ,'rowvect'         ,'mdshelp','a row vector',...
    'mdsvalid','1','srcsrv',mdsserver,'srctree',mdstree));
obj=obj.addparameter(SCDclass_mdsparnumeric('cfs1.params.colvect'       ,'colvect'         ,'mdshelp','a column vector',...
    'mdsvalid','1','srcsrv',mdsserver,'srctree',mdstree));
obj=obj.addparameter(SCDclass_mdsparnumeric('cfs1.params.matrix'        ,'matrix'          ,'mdshelp','a matrix',...
    'mdsvalid','1','srcsrv',mdsserver,'srctree',mdstree));

%% 2nd tunable parameters structure/parameters
% obj=obj.addtunparamstruct('algo_cfs1_tp2', @()algo_cfs1_loadtp(), false);
% obj=obj.addparameter(SCDclass_mdsparnumeric('cfs1.params.kb1','enable'          ,'srcsrv','spcpc171.epfl.ch','srctree','martetest','shot',parshot)); 

%% Wavegens
obj=obj.addwavegenbasetruct('algo_cfs1_inbus1');
obj=obj.addwavegen(SCDclass_mdswgsigsingle( 'cfs1.inputs.signal1','signal1'        ,'srcsrv',mdsserver,'srctree',mdstree));
obj=obj.addwavegen(SCDclass_mdswgsigsingle( 'cfs1.inputs.signal2','signal2'        ,'srcsrv',mdsserver,'srctree',mdstree));

%% 2nd wavegen base structure/signals
% obj=obj.addwavegenbasetruct('algo_cfs1_inbus2');
% obj=obj.addwavegen(SCDclass_mdswgsigsingle( 'ai.ch003','signal1'        ,'srcsrv','spcpc171.epfl.ch','srctree','martetest','shot',parshot));
% obj=obj.addwavegen(SCDclass_mdswgsigsingle( 'ai.ch004','signal2'        ,'srcsrv','spcpc171.epfl.ch','srctree','martetest','shot',parshot));


%% Buses
obj = obj.addbus('algo_cfs1_inBus', 'algo_cfs1_inBus_def' );
obj = obj.addbus('algo_cfs1_outBus', 'algo_cfs1_outBus_def' );
 % function handle that returns cell arays of buses and busnames to be
 % registered
obj = obj.addbus('',@() algo_cfs1_signal_buses());
%obj = obj.addbus('',@() algo_cfs1_proc_out_bus());
%obj = obj.addbus('',@() algo_cfs2_proc_out_bus());

%% Tasks

%% Print (optional)
obj.printinfo;

end

